#!/usr/bin/env python3
#coding:utf-8

import os
import sys
import ctypes
import struct

'''
 * uart config struct
 * 
typedef struct _uart_fomat
{
    uint32_t fomat_time;
    uint32_t fomat_lenth;
} uart_format_t;

typedef struct _at_cmd_uart_status
{
    uint32_t baud_rate;
    mhal_uart_config_t uart_config;
} at_cmd_uart_status_t;

typedef struct _at_cmd_uart_config
{
    uint32_t is_default;
    at_cmd_uart_status_t uart_config;
    uart_format_t format_config;
    uint8_t is_echo;
} at_cmd_uart_config_t;
'''

kv_cdll = ctypes.CDLL(os.path.abspath(f'kv-{sys.platform}.so'))
        
if __name__ == "__main__":
    out = "kvro.bin"

    kv_data = b'\xFF' * 1024 * 8
    baud=int(input("Please input uart baudrate(default 115200):") or "115200")
    print("uart baudrate is: ", baud)
    formattime=int(input("Please input format time(default 100ms):") or "100")
    print("format length: ", formattime)
    formatlen=int(input("Please input format time(default 1024):") or "1024")
    print("format length: ", formatlen)
    uart = struct.pack("3I4B3IB", 0xABC123, baud, baud, 3, 0, 0, 0, 1024, formattime, formatlen, 1)
    
    kv_cdll.kv_write(kv_data, "at_uart".encode() + b'\0', uart, len(uart), 512)
    with open(out, 'wb') as file:
        print('write kvro.bin')
        file.write(kv_data)
        file.close()